#ifndef _H_UTILITIES
#define _H_UTILITIES

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include "Point.h"

class Utilities{
private:
	std::string comandos;
	int tamanho_da_cadeia;
	std::vector<std::vector<int> > Matriz;

public:
	int poligono;
	int closed;
	int R, C, N;
	std::vector<mas::Point> Vertices;
	std::vector<mas::Point> Arestas;
	std::map<mas::Point, int> Mapa;
	std::vector<mas::Point> pontos;

	Utilities::Utilities()
	{
	}

	Utilities::~Utilities()
	{
	}

	void Read(std::istream& input)
	{
		input >> tamanho_da_cadeia;
		input >> comandos;
	}

	void WriteVector(std::ostream& output, std::vector<std::pair<int, int> >& Vector)
	{
		for(int i=0; i<static_cast<int>(Vector.size()); i++)
		{
			output << Vector[i].first << " " << Vector[i].second << std::endl;
		}
	}

	bool IsClosed()
	{
		int u_ = 0;
		int r_ = 0;
		int d_ = 0;
		int l_ = 0;
		for(int i=0; i<static_cast<int>(comandos.size()); i++)
		{
			if(comandos[i] == 'u')
			{
				u_++;
			}
			if(comandos[i] == 'r')
			{
				r_++;
			}
			if(comandos[i] == 'd')
			{
				d_++;
			}
			if(comandos[i] == 'l')
			{
				l_++;
			}
		}
		if((l_==r_) && (u_==d_) && u_!=0 && d_!=0 && l_!=0 && r_!=0)
			return true;
		else
			return false;
	}

	bool IsPoligono()
	{
		if(IsClosed())
		{
			mas::Point p;
			int sig = 1;
			for(int i=0; i<static_cast<int>(Vertices.size()); i++)
			{
				p.Set(Vertices[i].X(), Vertices[i].Y());
				Mapa[p]++;
				if(Mapa[p] > 1)
				{
					if((i != static_cast<int>(Vertices.size())) || (p.X() !=0 || p.Y() != 0))
					{
						sig = 0;
						break;
					}
				}
			}
			if(sig == 0)
				return false;
			else
				return true;
		}
		else
			return false;
	}
	void GetVertices()
	{
		mas::Point p;
		for(int i=0; i<static_cast<int>(comandos.size()); i++)
		{
			if(comandos[i] == 'u')
			{
				p.Translate(0,1);
			}
			if(comandos[i] == 'r')
			{
				p.Translate(1,0);
			}
			if(comandos[i] == 'd')
			{
				p.Translate(0,-1);
			}
			if(comandos[i] == 'l')
			{
				p.Translate(-1,0);
			}
			Vertices.push_back(p);
		}
	}

	void GetArestas()
	{
		mas::Point p;
		p.Set(0,0);
		Arestas.push_back(p);
		for(int i=0; i<static_cast<int>(comandos.size())-1; i++)
		{
			if(comandos[i] != comandos[i+1])
			{
				Arestas.push_back(Vertices[i]);
			}
		}
	}

	int GetSides()
	{
		int lados = 0;
		for(int i=0; i<=tamanho_da_cadeia-1; i++)
		{
			if(comandos[i] != comandos[i+1])
				lados++;
		}
		if(comandos[0] == comandos[tamanho_da_cadeia-1])
		{
			lados--;
		}
		return lados;
	}

	double AreaPoligono()
	{
		double valor = 0;
		for(int i=0; i<static_cast<int>(Vertices.size())-1; i++)
		{
			valor += ( (Vertices[i].X()*Vertices[i+1].Y()) - (Vertices[i+1].X()*Vertices[i].Y()) );
		}
		valor = valor/2;
		return valor;
	}

	int InsideOut(mas::Point p)
	{
		int interseccao = 0;
		for(int i=0; i<static_cast<int>(Arestas.size())-1; i++)
		{
			if(p.Y() > Arestas[i].Y() && p.Y() < Arestas[i+1].Y())
			{
				if( p.X() > Arestas[i].X())
					interseccao++;
			}
		}
		if(p.Y() > Arestas[static_cast<int>(Vertices.size())-1].Y() && p.Y() < Arestas[0].Y())
			interseccao++;
		if(interseccao%2 == 0)
			return 0;
		else
			return 1;
	}

	bool IsPerimeter(mas::Point p)
	{
		int valor = 0;
		for(int i=0; i<static_cast<int>(Vertices.size()); i++)
		{
			if(Vertices[i] == p)
			{
				valor = 1;
				break;
			}
			else
				valor = 0;
		}
		if(valor == 0)
			return false;
		else
			return true;
	}

	void Matriz_FILL()
	{
		int x = 0;
		int y = 0;
		std::vector<int> temp;
		for(int j=0; j<=C; j++)
		{
			temp.push_back(0);
		}
		for(int i=0; i<=R; i++)
		{
			Matriz.push_back(temp);
		}
		for(int i=0; i<N; i++)
		{
			Matriz[y][x] = 1;
			x = (2+x)%C;
			y = (2+y)%R;
		}
	}

	void Matriz_WRITE()
	{
		if(!(C <= 20 && R <= 20))
		{
			int uns = 0;
			int zeros = 0;
			for(int i=0; i<R; i++)
			{
				for(int j=0; j<C; j++)
				{
					if(Matriz[i][j] == 1)
						uns++;
					else
						zeros++;
				}
			}
			std::cout << zeros << " " << uns << std::endl;
		}
		else
		{
			for(int i=0; i<R; i++)
			{
				for(int j=0; j<C; j++)
				{
					std::cout << Matriz[i][j];
				}
				std::cout << std::endl;
			}
		}
	}

	std::vector<mas::Point> VIZINHOS(mas::Point p)
	{
		int x_ = static_cast<int>(p.X());
		int y_ = static_cast<int>(p.Y());
		std::vector<mas::Point> vizinhos;
		for(int i=-1; i<=1; i++)
		{
			for(int j=-1; j<=1; j++)
			{
				if(((x_+i)>=0 && (x_+i)<C) && ((y_+j)>=0 && (y_+j)<R))
				{
					if(Matriz[y_+j][x_+i] == 1)
					{
						mas::Point t;
						t.Set(x_+i, y_+j);
						vizinhos.push_back(t);
					}
				}
			}
		}
		return vizinhos;
	}

	void MATRIZREAD(std::istream& input)
	{
		input >> R >> C >> N;
		Matriz_FILL();
	}

	void MATRIXREAD_PONTOS(std::istream &input)
	{
		pontos.clear();
		int P;
		input >> P;
		for(int i=0;i<P;i++)
		{
			mas::Point p;
			int x=0;
			int y=0;
			input >> x >> y;
			p.Set(x, y);
			pontos.push_back(p);
		}
	}

};

#endif
